#!/usr/bin/perl -w

use strict;
use warnings;


my $usage = << "USE";
	
	Split large chromosomes.
	
	Usage: fasta splitter
	perl ngm_splitter.pl <genome fasta> <max size>
USE

my $argcount = $#ARGV + 1;
my $reqArgs = 2;
$argcount == $reqArgs or die "$usage";

my $file_path = $ARGV[0];
my $size = $ARGV[1] * 1000000;

open(FHI, "<$file_path") or die "Unable to open file $file_path \n";

#my $current = 0;
#my $current_id = "";
#my $current_position = 0;
#my $current_size = 0;
#my $last_position = 0;

####################################

my $current_header = "";
my $current_sequence = "";
my $file_number = 0;
my $current_size = 0;
open(FHO, ">$file_path" . "_$file_number") or die "Unable to open file $file_path" . "_$file_number \n";

while(<FHI>) {

	if(/^>/) {
		if(length($current_header) > 0) {
			#Not first chromosome
			if($current_size != 0 && (($current_size + length($current_sequence)) > $size)) {
				close(FHO);
				$file_number += 1;
				open(FHO, ">$file_path" . "_$file_number") or die "Unable to open file $file_path" . "_$file_number \n";	
				$current_size = 0;
			}
			print FHO $current_header . "\n";
			print FHO $current_sequence;
			$current_size += length($current_sequence);
			$current_sequence = "";
		}
		chomp($_);
		$current_header = $_;
	} else {
		$current_sequence .= $_;
	}
}
if(length($current_header) > 0) {
	#Not first chromosome
	if($current_size != 0 && (($current_size + length($current_sequence)) > $size)) {
		close(FHO);
		$file_number += 1;
		open(FHO, ">$file_path" . "_$file_number") or die "Unable to open file $file_path" . "_$file_number \n";	
		$current_size = 0;
	}
	print FHO $current_header . "\n";
	print FHO $current_sequence;
	$current_size += length($current_sequence);
	$current_sequence = "";
}

close(FHI);
close(FHO);

